<?php
/* Configuration Area */

$phpbbhost = 'localhost'; // database host for phpbb
$phpbbuser = 'root'; // database username for phpbb
$phpbbpass = ''; // database password for phpbb
$phpbbdb = 'importtests'; // database name for phpbb
$phpbbprefix = 'phpbb_'; // tables prefix for phpbb (usually phpbb_)

$wsnhost = 'localhost'; // database host for WSN
$wsnuser = 'root'; // database username for WSN
$wsnpass = ''; // database password for WSN
$wsndb = 'importtests'; // database name for WSN
$wsnprefix = 'wsnforum_'; // tables prefix for WSN (usually wsnforum_)

/* End of configuration area */

if ($_GET['table'] == 'forums' && $start = 0)
{
 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);	
// Do any needed field additions and changes here:

// none known to be needed for phpbb
} 
?>
<html>
<head><title>phpBB2 to WSN Forum Importer</title></head>
<body>
<img src="http://www.wsnforum.com/logo.jpg" border="0">
<div style="border-width: 1px; border-color: #666666; background: #EEEEEE; margin: 5px; padding: 5px; <?php if ($_GET['continue']) echo 'height: 0px; visibility: hidden;'; ?>">
<form action="phpbbimport.php">
<?php 
//globalize
$action = $_GET['action'];
$table = $_GET['table'];
$continue = $_GET['continue'];
$continueall = $_GET['continueall'];
$start = $_GET['start'];
$number = $_GET['number'];

 if ($phpbbuser == '' || $wsnuser == '')
 {
	die('<p>You have not yet edited this file to write your database info in the area at the top. Please do so, then reload this page.</p> </div></body></html>');
 }
if ($_GET['action'] == 'truncate')
{
 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
 $query = "TRUNCATE TABLE ". $wsnprefix ."members";
 $doit = mysqli_query($connection, $query); 
 $query = "TRUNCATE TABLE ". $wsnprefix ."categories";
 $doit = mysqli_query($connection, $query);  
 $query = "TRUNCATE TABLE ". $wsnprefix ."links";
 $doit = mysqli_query($connection, $query); 	
 $query = "TRUNCATE TABLE ". $wsnprefix ."pm";
 $doit = mysqli_query($connection, $query); 
 $query = "TRUNCATE TABLE ". $wsnprefix ."polls";
 $doit = mysqli_query($connection, $query); 
 $query = "TRUNCATE TABLE ". $wsnprefix ."pollvotes";
 $doit = mysqli_query($connection, $query); 
 $query = "TRUNCATE TABLE ". $wsnprefix ."comments";
 $doit = mysqli_query($connection, $query);  
	die('<p>Tables are now emptied. You may <a href="phpbbimport.php">begin importing</a> now.</p> </div></body></html>');
}	
?>
<input type="hidden" name="action" value="transfer">
<p>Before you begin, you'll need to <a href="phpbbimport.php?action=truncate">empty your WSN Forum members, forums, pm, poll and topics tables</a>. </p>
<p>
Transfer <input type="text" name="number" size="3" value="500"> records (at a time) starting at record #<input type="text" size="3" name="start" value="0">,  
from table 
<select name="table">
<option value="forums">forums</option>
<option value="posts">posts</option>
<option value="polls">polls</option>
<option value="pollvotes">poll votes</option>
<option value="topics">threads</option>
<option value="profiles">users</option>
<option value="pmsg">private messages</option>
</select>
.</p>
<p><input type="checkbox" name="continue" value="1"> Continue doing this many at a time until complete?
<br><input type="checkbox" name="continueall" value="1"> Continue to next table until complete?
<br>(Check both boxes to start a complete import.)
</p>
<p><input type="submit" value="Begin Import"></p>
</form>
</div>
<div style="border-width: 1px; border-color: #666666; background: #EEEEEE; margin: 5px; padding: 5px;">
<?php

set_time_limit(500);
if ($action=="transfer")
{
 echo "<p>Transfering $number records starting at ". $start ." from the table $table</p>";
 $connection = mysqli_connect($phpbbhost, $phpbbuser, $phpbbpass);
 mysqli_select_db($connection, $phpbbdb);

 if ($table=="forums")
 {
  $query = "SELECT forum_id,forum_name,forum_desc,forum_posts,forum_topics,forum_order FROM ". $phpbbprefix ."forums ORDER BY forum_id LIMIT $start,$number";
 $doit = mysqli_query($connection, $query);
 $num = mysqli_num_rows($doit);
 for ($count=0;$count<$num;$count++)
 {
 $row = mysqli_fetch_row($doit);
 $id[$count] = $row[0];
 $title[$count] = encodeit($row[1]);
 $description[$count] = encodeit(stripslashes($row[2]));
 $postcount[$count] = $row[3];
 $threadcount[$count] = $row[4];
 $displayorder[$count] = $row[5];
 }

mysqli_close($connection);

 // send

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb); 
 for ($count=0;$count<$num;$count++)
 {
 $query = "INSERT INTO ". $wsnprefix ."categories(id,name,description,priority,numlinks,totalcomments,parent,validated,type) values('$id[$count]', '$title[$count]', '$description[$count]', '$displayorder[$count]', '$threadcount[$count]', '$postcount[$count]', '0', '1', 'regular')";
echo "<p>Performing query: $query</p>"; 
 if ($parent[$count] >= 0) $doit = mysqli_query($connection, $query); 
echo mysqli_error(); 
 }
}

 if ($table=="posts")
 {
  $query = "SELECT post_id,topic_id,post_username,post_time,poster_id FROM ". $phpbbprefix ."posts ORDER BY post_id ASC LIMIT $start,$number ";
  $doit = mysqli_query($connection, $query);
  $num = mysqli_num_rows($doit);  
  for ($count=0; $count < $num; $count++)
  {
	$row = '';  
   $row = mysqli_fetch_row($doit);
   $postid[$count] = $row[0];
   $threadid[$count] = $row[1];
   $poster[$count] = encodeit($row[2]);
  $dateline[$count] = $row[3];
   $userid[$count] = $row[4];

  $q2 = "SELECT post_text,post_subject,bbcode_uid FROM ". $phpbbprefix ."posts_text WHERE post_id=". $row[0];
  $d2 = mysqli_query($q2, $connection);
  $n2 = mysqli_num_rows($d2);  
  $r2 = '';  
  if ($n2) 
  { 
   $r2 = mysqli_fetch_row($d2); 
   $me = str_replace(':'. $r2[2], '', $r2[0]);   
   $message[$count] = encodeit(securityfixes($me));   
   $title[$count] = encodeit($r2[1]);
 }

  }  
mysqli_close($connection);

 // send

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; (($count < $number) && ($postid[$count]!='') ); $count++)
  {
   $query = "INSERT INTO ". $wsnprefix ."comments(id,linkid,postername,ownerid,title,time,message,lastedit,validated,deleted,deletedby,deletionreason,ip) values('$postid[$count]','$threadid[$count]','$poster[$count]','$userid[$count]','$title[$count]','$dateline[$count]','$message[$count]','$update[$count]', '1', '$deleted[$count]', '$deletedby[$count]', '$reason[$count]','$ip[$count]')";
   echo "<p>Performing query: $query</p>";   
   $doit = mysqli_query($connection, $query);
   echo mysqli_error();   
   }
 }

 if ($table=="polls")
 {
  $query = "SELECT vote_id,vote_text,vote_start,topic_id FROM ". $phpbbprefix ."vote_desc ORDER BY vote_id ASC LIMIT $start,$number";
  $doit = mysqli_query($connection, $query);
echo "<p>$query</p>". mysqli_error();  
   $num = mysqli_num_rows($doit);  
   for ($count=0; $count < $num; $count++)
  {
   $row = mysqli_fetch_row($doit);
   $pollid[$count] = $row[0];
   $question[$count] = encodeit($row[1]);
   $dateline[$count] = $row[2];   
   $topicid[$count] = $row[3];

  $q2= "SELECT vote_option_text FROM ". $phpbbprefix ."vote_results ORDER BY vote_option_id ASC";
  $d2 = mysqli_query($q2, $connection); 
  $n2 =  mysqli_num_rows($d2);
  $op = ''; 
  for ($xx=0; $xx<$n2; $xx++)
  {
 	$r2 = mysqli_fetch_row($d2); 
	$op .= $r2[0] ."\r\n";
   }
   $options[$count] = encodeit(trim($op));
  }
mysqli_close($connection);

 // send

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; (($count < $num) && ($pollid[$count]!='') ); $count++)
  {
  $query = "INSERT INTO ". $wsnprefix ."polls(id,question,time,options,totals,topicid,catid) VALUES('$pollid[$count]','$question[$count]','$dateline[$count]','$options[$count]','$totals[$count]','$topicid[$count]','$catid[$count]');";
  $doit = mysqli_query($connection, $query); 
echo "<p>$query</p>". mysqli_error(); 
   }
 }
 
 if ($table=="pollvotes")
 {
	 // phpbb doesn't appear to track invidivual votes
	/* 
  $query = "SELECT pollvoteid,pollid,userid,votedate,voteoption FROM ". $phpbbprefix ."pollvote ORDER BY pollvoteid ASC LIMIT $start,$number";
  $doit = mysqli_query($connection, $query);
echo "<p>$query</p>". mysqli_error();  
   $num = mysqli_num_rows($doit);  
   for ($count=0; $count < $num; $count++)
  {
   $row = mysqli_fetch_row($doit);
   $id[$count] = $row[0];   
   $pollid[$count] = $row[1];
	$memberid[$count] = $row[2];
	$time[$count] = $row[3];
	$vote[$count] = $row[4];
  }
mysqli_close($connection);

 // send

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; (($count < $num) && ($pollid[$count]!='') ); $count++)
  {
  $query = "INSERT INTO ". $wsnprefix ."pollvotes(id,pollid,memberid,time,vote) VALUES('$id[$count]','$pollid[$count]','$memberid[$count]','$time[$count]','$vote[$count]');";
  $doit = mysqli_query($connection, $query); 
echo "<p>$query</p>". mysqli_error(); 
   }
*/
 }  

 if ($table=="topics")
 { 
  $query = "SELECT topic_id,topic_title,topic_last_post_id,forum_id,topic_vote,topic_status,topic_replies,topic_poster,topic_time,topic_views FROM ". $phpbbprefix ."topics ORDER BY topic_id ASC LIMIT $start,$number";
  $doit = mysqli_query($connection, $query);
  $num = mysqli_num_rows($doit);    
  for ($count=0; $count < $num; $count++)
  {
   $row = mysqli_fetch_row($doit);
   $threadid[$count] = $row[0];
   $title[$count] = encodeit($row[1]);
   $last[$count] = $row[2];
   $forum[$count] = $row[3];
   $q2 = "SELECT vote_id FROM ". $phpbbprefix ."vote_desc WHERE topic_id=". $row[0];
   $d2 = mysqli_query($q2, $connection);
   $n2 = mysqli_num_rows($d2);
   if ($n2) { $r2 = mysqli_fetch_row($d2); $pollid[$count] = $r2[0]; }
   if ($row[5]=='1') $open[$count]=1; else $open[$count]=0;
   $replies[$count] = $row[6];
   $posterid[$count] = $row[7];   
   $dateline[$count] = $row[8];
   $views[$count] = $row[9];

  $q2 = "SELECT username FROM ". $phpbbprefix ."users WHERE user_id=". $posterid[$count];
  $d2 = mysqli_query($q2, $connection);
  $n2 = mysqli_num_rows($d2);  
  if ($n2) { $r2 = mysqli_fetch_row($d2); $poster[$count] = $r2[0]; }

  }

mysqli_close($connection);

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; ( ($count < $number) && ($threadid[$count] != '') ); $count++)
    {
   $query = "INSERT INTO ". $wsnprefix ."links(id,title,catid,pollid,numcomments,ownername,ownerid,time,hits,validated,threadclosed,type,deleted,deletedby,deletionreason) values('$threadid[$count]','$title[$count]','$forum[$count]','$pollid[$count]','$replies[$count]','$poster[$count]','$posterid[$count]','$dateline[$count]','$views[$count]','1','$open[$count]','regular','$deleted[$count]','$deletedby[$count]','$deletionreason[$count]')";
   echo "<p>Performing query: $query</p>";   
   $doit = mysqli_query($connection, $query);
   echo mysqli_error();
  }
 }

 mysqli_close($connection); 
}

 if ($table=="profiles")
 {
  $query = "SELECT user_id,user_level,username,user_password,user_email,user_website,user_icq,user_aim,user_yim,user_regdate,user_lastvisit,user_posts,user_interests,user_sig,user_msnm,user_from FROM ". $phpbbprefix ."users WHERE user_id > 0 ORDER BY user_id ASC LIMIT $start,$number";
 $connection = mysqli_connect($phpbbhost, $phpbbuser, $phpbbpass);
 mysqli_select_db($connection, $phpbbdb);  
  $doit = mysqli_query($connection, $query);
  $num = mysqli_num_rows($doit);    
  for ($count=0; $count < $num; $count++)
  {
   $row = mysqli_fetch_row($doit);
   $userid[$count] = $row[0];   
   if ($userid[$count] == '2') $row[1] = 3; 
   else $row[1] = 2;   
   $usergroupid[$count] = $row[1];   
   $username[$count] = encodeit($row[2]);
   $password[$count] = encodeit($row[3]);
   $email[$count] = $row[4];
   if ($homepage[$count] != 'http://') $homepage[$count] = encodeit($row[5]);
   $icq[$count] = encodeit($row[6]);
   $aim[$count] = encodeit($row[7]);
   $yahoo[$count] = encodeit($row[8]);
   $joindate[$count] = $row[9];
   $lastactive[$count] = $row[10];   
   $posts[$count] = $row[11];   
   $interests[$count] = encodeit($row[12]);   
   $signature[$count] = encodeit($row[13]);
   $msn[$count] = encodeit($row[14]);   
   $location[$count] = encodeit($row[15]);   
  }

mysqli_close($connection);

// now insert into wsn
 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; ( ($count < $number) && ($userid[$count] != '') ); $count++)
  { 
 $query = "INSERT INTO ". $wsnprefix ."members(id,name,password,email,homepage,icq,aim,yahoo,signature,bio,location,interests,occupation,time,lastvisit,lastsession,posts,timezone,birthdate,customtitle,usergroup,validated,banned) values('$userid[$count]', '$username[$count]', '$password[$count]', '$email[$count]', '$homepage[$count]', '$icq[$count]', '$aim[$count]', '$yahoo[$count]', '$signature[$count]', '$bio[$count]', '$location[$count]', '$interests[$count]', '$occupation[$count]', '$joindate[$count]', '$lastactive[$count]', '$lastactive[$count]', '$posts[$count]', '$timezone[$count]', '$birthdate[$count]', '$custom[$count]', '$usergroupid[$count]', '1', '$banned[$count]')";
echo "<p>Performing query: $query</p>"; 
  $doit = mysqli_query($connection, $query);
echo mysqli_error();    

  }

}

if ($table=="pmsg")
{
 $query = "SELECT privmsgs_id,privmsgs_date,privmsgs_from_userid,privmsgs_to_userid,privmsgs_subject FROM ". $phpbbprefix ."privmsgs ORDER BY privmsgs_id ASC LIMIT $start,$number"; 
echo "<p> $query </p>"; 
 $connection = mysqli_connect($phpbbhost, $phpbbuser, $phpbbpass);
 mysqli_select_db($connection, $phpbbdb);  
 $doit = mysqli_query($connection, $query);
echo mysqli_error(); 
 $num = mysqli_num_rows($doit);   
 for ($count=0; $count < $num; $count++)
 {
 $row = mysqli_fetch_row($doit);
 $pmid[$count] = $row[0];
 $time[$count] = $row[1]; 
 $fromid = $row[2]; 
 $to[$count] = $row[3]; 
 $subject[$count] = encodeit(stripslashes($row[4]));
 if  (!$timeread) $timeread = 1;

 $q2 = "SELECT privmsgs_text,privmsgs_bbcode_uid FROM ". $phpbbprefix ."privmsgs_text WHERE privmsgs_text_id=". $row[0];
 $d2 = mysqli_query($q2, $connection);
 $n2 = mysqli_num_rows($d2);
 if ($n2) 
 { 
  $r2 = mysqli_fetch_row($d2); 
  $me = str_replace(':'. $r2[1], '', $r2[0]);  
  $message[$count] = encodeit(securityfixes(stripslashes($me))); 
  }
 }
 // send
mysqli_close($connection);

 $connection = mysqli_connect($wsnhost, $wsnuser, $wsnpass);
 mysqli_select_db($connection, $wsndb);
  for ($count=0; ( ($count < $number) && ($pmid[$count] != '') ); $count++)
  {
   if ($box[$count] >= 0)
   {
    $query = "INSERT INTO ". $wsnprefix ."pm(id,time,toid,fromid,subject,message,timeread)
     values('$pmid[$count]','$time[$count]','$to[$count]','$from[$count]','$subject[$count]','$message[$count]','$timeread[$count]')";
	 echo "<p>$query</p>"; 
    $doit = mysqli_query($connection, $query);
    echo mysqli_error();
   }
  }
 
}

$newstart = $start + $number;

if ($continueall)
{
  $table = $_GET['table'];
  if ($num > 0) 
  {
	echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start='. $newstart .'&number='. $number .'&table='. $_GET['table'] .'&action=transfer&continue=1&continueall=1">';
  }
  else
  {
	if ($table == 'forums') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=posts&action=transfer&continue=1&continueall=1">';
	else if ($table == 'posts') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=polls&action=transfer&continue=1&continueall=1">';
	else if ($table == 'polls') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=pollvotes&action=transfer&continue=1&continueall=1">';
	else if ($table == 'pollvotes') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=topics&action=transfer&continue=1&continueall=1">';
	else if ($table == 'topics') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=profiles&action=transfer&continue=1&continueall=1">';	
	else if ($table == 'profiles') echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start=0&number='. $number .'&table=pmsg&action=transfer&continue=1&continueall=1">';		
	else if ($table == 'pmsg') echo "<p><b>All done. You will now need to regenerate counters.</b></p>";
  }
}	
else if ($continue)
{
	if ($num > 0) echo '<meta http-equiv="refresh" content="5;url=phpbbimport.php?start='. $newstart .'&number='. $number .'&table='. $_GET['table'] .'&action=transfer&continue=1">';
	else echo '<p><b>Done with table.</b></p>';
}


function encodeit($item)
{
   $item = str_replace("'", "&#39;", $item);
   $item = str_replace('"', '&#34;', $item);
   return $item;
}

function securityfixes($msg)
{
 $msg = str_replace('&lt', '&#60', $msg);
 $msg = str_replace('&gt', '&#62', $msg);
 $msg = str_replace('{', '&#123;', $msg);
 return $msg;
}

function htmltowsn($msg)
{	
// translates html code in string to equivilant WSN codes(insofar as is possible)
global $iters, $removesmilies;
if (!$iters) $iters = 0; 
else $iters++;
$msg = securityfixes($msg);
$msg = str_replace(" target='_blank'", "", $msg); // make links work right
$msg = str_replace('&nbsp;', ' ', $msg);
$msg = str_replace("\r\n", " ", $msg); // newlines incidate edge of box, which we don't want to preserve. real line breaks are <br>, which we'll translate to \r\n later
$msg = stripslashes($msg);	
$msg = preg_replace('/<a onclick="javascript:update(.*?)">(.*?)<\/a>/i', '$2', $msg); // strip dragged smilies
$msg = preg_replace('/ alt="(.*?)"/i', '', $msg); // alt can't be specified in WSN code anyhow
$msg = preg_replace('/ alt=(.*?) /i', ' ', $msg); // alt can't be specified in WSN code anyhow
$msg = preg_replace('/ alt=(.*?)>/i', '', $msg); // alt can't be specified in WSN code anyhow
$msg = str_replace(' border="0"', '', $msg);  // border can't be specified in WSN code anyhow
$msg = str_replace(" border='0'", '', $msg); // border can't be specified in WSN code anyhow
$msg = str_replace(" border=0", '', $msg); // border can't be specified in WSN code anyhow
$msg = str_replace(" style='vertical-align:middle'", '', $msg);
$msg = preg_replace('/<img src="(.*?)\/smilies\//i', '<img src="{TEMPLATESDIR}/images/smilies/', $msg); // undo template specification in smilie
if (!$removesmilies) $msg = reversesmilies($msg);
$msg = preg_replace('/<span style="font-weight: bold;">(.*?)<\/span>/i', '[b]$1[/b]', $msg);   
$msg = preg_replace('/<b>(.*?)<\/b>/i', '[b]$1[/b]', $msg);     
$msg = preg_replace('/<span style="font-style: italic;">(.*?)<\/span>/i', '[i]$1[/i]', $msg);   
$msg = preg_replace('/<i>(.*?)<\/i>/i', '[i]$1[/i]', $msg);      
$msg = preg_replace('/<span style="font-weight: bold; font-style: italic;">(.*?)<\/span>/i', '[b][i]$1[/i][/b]', $msg);   
$msg = preg_replace('/<span style="font-style: italic; font-weight: bold;">(.*?)<\/span>/i', '[b][i]$1[/i][/b]', $msg);   
$msg = preg_replace('/<span style="font-weight: bold; font-style: italic; text-decoration: underline;">(.*?)<\/span>/i', '[b][i][u]$1[/u][/i][/b]', $msg);   
$msg = preg_replace('/<span style="font-weight: bold; text-decoration: underline;">(.*?)<\/span>/i', '[b][u]$1[/u][/b]', $msg);   
$msg = preg_replace('/<span style="font-style: italic; text-decoration: underline;">(.*?)<\/span>/i', '[i][u]$1[/u][/i]', $msg);
$msg = preg_replace('/<span style="font-style: italic; font-weight: bold; font-family: (.*?)">(.*?)<\/span>/i', '[i][b][font=$1]$2[/font][/b][/i]', $msg);   
$msg = preg_replace('/<span style="text-decoration: underline;">(.*?)<\/span>/i', '[u]$1[/u]', $msg);   
$msg = preg_replace('/<u>(.*?)<\/u>/i', '[u]$1[/u]', $msg);      
$msg = preg_replace('/<span style="color: (.*?)">(.*?)<\/span>/i', '[color=$1]$2[/color]', $msg);      
$msg = preg_replace('/<span style="font-family: (.*?)">(.*?)<\/span>/i', '[font=$1]$2[/font]', $msg);   
$msg = preg_replace('/<ul>(.*?)<\/ul>/i', '[list]$1[/list]', $msg);   
$msg = preg_replace('/<font size=(.*?)>(.*?)<\/font>/i', '[size=$1]$2[/size]', $msg);         
$msg = preg_replace('/<ol>(.*?)<\/ol>/i', '[numbered]$1[/numbered]', $msg);       
$msg = preg_replace('/<img src=(.*?)>/i', '[img]$1[/img]', $msg);              
$msg = preg_replace('/<span style="background-color: (.*?)">(.*?)<\/span>/i', '[highlight=$1]$2[/highlight]', $msg);         
$msg = preg_replace("#<span style=\"font-weight: normal;\" class=\"labels\">(.*?)</span>#is" , "\\1", $msg);      
$msg = preg_replace("#<a target=\"_blank\" href=\"(.*?)\">(.*?)</a>#is" , "[url=\\1]\\2[/url]", $msg);      
$msg = preg_replace("#<a target=_blank href=\"(.*?)\">(.*?)</a>#is" , "[url=\\1]\\2[/url]", $msg);     
$msg = preg_replace("#<a href=\"(.*?)\" target=\"_blank\">(.*?)</a>#is" , "[url=\\1]\\2[/url]", $msg);     
$msg = preg_replace("#<a href=\"(.*?)\" target=_blank>(.*?)</a>#is" , "[url=\\1]\\2[/url]", $msg);   
$msg = preg_replace("#<a href=\"(.*?)\">(.*?)</a>#is" , "[url=\\1]\\2[/url]", $msg);     

// begin IE-only translations:
$msg = preg_replace("#<p align=center>(.*?)</p>#is" , "[center]\\1[/center]", $msg);
$msg = preg_replace('/<strong>(.*?)<\/strong>/i', '[b]$1[/b]', $msg); 
$msg = preg_replace('/<em>(.*?)<\/em>/i', '[i]$1[/i]', $msg); 
$msg = preg_replace('/<font style=BACKGROUND-COLOR: (.*?)>(.*?)<\/font>/i', '[highlight=$1]$2[/highlight]', $msg);        
$msg = preg_replace('/<font style="BACKGROUND-COLOR: (.*?)">(.*?)<\/font>/i', '[highlight=$1]$2[/highlight]', $msg);         
$msg = preg_replace('/<font color=(.*?)>(.*?)<\/font>/i', '[color=$1]$2[/color]', $msg);  
$msg = preg_replace("#<div align=left>(.*?)</div>#is" , "[left]\\1[/left]", $msg);       
$msg = preg_replace("#<p align=right>(.*?)</p>#is" , "[right]\\1[/right]", $msg);      
$msg = preg_replace("#<p align=left>(.*?)</p>#is" , "[left]\\1[/left]", $msg);  
$msg = preg_replace("#<p>(.*?)</p>#is" , "<br>\\1<br>", $msg);  
$msg = preg_replace("#<p (.*?)>(.*?)</p>#is" , "<br>\\2<br>", $msg);  
$msg = preg_replace("#<hr>#is" , "[hr]", $msg);  
$msg = preg_replace('/<font face=(.*?)>(.*?)<\/font>/i', '[font=$1]$2[/font]', $msg);         
$msg = preg_replace('/<font face="(.*?)" size=(.*?)>(.*?)<\/font>/i', '[font="$1"][size=$2]$3[/size][/font]', $msg);   

// end IE-only translations

 // for some reason, this alternate syntax is required for it to work with <div> tags:   
$msg = preg_replace("#<div style=\"text-align: right;\">(.*?)</div>#is" , "[right]\\1[/right]", $msg);      
$msg = preg_replace("#<div style=\"margin-left: (.*?)px;\">(.*?)</div>#is" , "[indent=\\1]\\2[/indent]", $msg);      
$msg = preg_replace("#<div style=\"text-align: center; font-weight: bold; font-style: italic;\">#is" , "[center][b][i]\\1[/i][/b][/center]", $msg);   
$msg = preg_replace('/<a href=(.*?)>(.*?)<\/a>/i', '[url=$1]$2[/url]', $msg);      
$msg = preg_replace("#<li>(.*?)</li>#is" , "[*]\\1", $msg); 
$msg = preg_replace("#<li(.?)>(.*?)</li>#is" , "[*]\\2", $msg); 
$msg = preg_replace("#<ul>(.*?)</ul>#is" , "[list]\\1[/list]", $msg); 
$msg = preg_replace("#<hr style=(.*?)>#is" , "[hr]", $msg);      
if (strstr($msg, '<') && $iters) $msg = htmltowsn($msg); // recursion -- careful! do only 3 times
$msg = str_replace('<br>', "\r\n", $msg);	
$msg = str_replace('<BR>', "\r\n", $msg);
$msg = preg_replace("#<br style=(.*?)>#is" , "\r\n", $msg);      

 // just eliminate any remaining html junk
$search = array ("'<script[^>]*?>.*?</script>'si", "'<[\/\!]*?[^<>]*?>'si");                  
$replace = array ("", "");
$msg = preg_replace($search, $replace, $msg);

 return $msg;
}	

function reversesmilies($message)
{ 
 global $phpbbsmiliepath;
 $message = str_replace("<!--emo&:nod:--><img src='". $phpbbsmiliepath ."nod.gif' border='0' style='vertical-align:middle' alt='nod.gif' /><!--endemo-->", ":nod:", $message);
 $message = str_replace("<!--emo&:)--><img src='". $phpbbsmiliepath ."smile.gif' border='0' style='vertical-align:middle' alt='smile.gif' /><!--endemo-->", ":)", $message);
 $message = str_replace("<!--emo&:confused:--><img src='". $phpbbsmiliepath ."sick.gif' border='0' style='vertical-align:middle' alt='sick.gif' /><!--endemo-->", ":confused:", $message);
 $message = str_replace("<!--emo&:(--><img src='". $phpbbsmiliepath ."sad.gif' border='0' style='vertical-align:middle' alt='sad.gif' /><!--endemo-->", ":sad:", $message);
 $message = str_replace("<!--emo&:D--><img src='". $phpbbsmiliepath ."grin.gif' border='0' style='vertical-align:middle' alt='grin.gif' /><!--endemo-->", ":D", $message);
 $message = str_replace("<!--emo&;)--><img src='". $phpbbsmiliepath ."wink.gif' border='0' style='vertical-align:middle' alt='wink.gif' /><!--endemo-->", ";)", $message); 
 return $message;
}

?>
</div>
</body>
</html>